﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace S01LCSingle
{
    public partial class Form1 : Form
    {
        const short devId = 0;//装置のID

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short Ret;
            try
            {
                Ret = TUSBSLC.Tusbs01lc_Device_Open(devId);
                if (Ret != 0)
                {
                    MessageBox.Show(TUSBSLC.GetErrMessage(Ret));
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                this.Close();
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (StartStopBtn.Text == "停止")
            {
                MeasStop();
            }
            TUSBSLC.Tusbs01lc_Device_Close(devId);
        }

        private void MeasStart()
        {
            Timer1.Enabled = true;
            StartStopBtn.Text = "停止";
            ZeroBtn.Enabled = false;
        }

        private void MeasStop()
        {
            Timer1.Enabled = false;
            StartStopBtn.Text = "開始";
            ZeroBtn.Enabled = true;
        }

        private void StartStopBtn_Click(object sender, EventArgs e)
        {
            switch (StartStopBtn.Text)
            {
                case "開始":
                    MeasStart();
                    break;
                case "停止":
                    MeasStop();
                    break;
            }
        }

        private void ZeroBtn_Click(object sender, EventArgs e)
        {
            short Ret;
            double tmpData;
            double Data;
            short Cnt;

            // 先ずゼロ調整をクリアする
            Ret = TUSBSLC.Tusbs01lc_Zero_Adj(devId, 0.0);
            if (Ret != 0)
            {
                MessageBox.Show(TUSBSLC.GetErrMessage(Ret));
                return;
            }

            // 調整が無い時の値を取得する(平均化)
            Data = 0.0;
            for (Cnt = 0; Cnt < 100; Cnt++)
            {
                Ret = TUSBSLC.Tusbs01lc_Single_Sample(devId, out tmpData);
                if (Ret != 0)
                {
                    MessageBox.Show(TUSBSLC.GetErrMessage(Ret));
                    return;
                }
                Data += tmpData;
            }
            Data /= 100.0;

            // 調整する
            Ret = TUSBSLC.Tusbs01lc_Zero_Adj(devId, Data);
            if (Ret != 0)
            {
                MessageBox.Show(TUSBSLC.GetErrMessage(Ret));
                return;
            }
        }

        private void Timer1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            short Ret;
            int Cnt;
            double tmpData;
            double Data;//データ

            Timer1.Enabled = false;//タイマーは一旦停止
            Data = 0.0;
            for (Cnt = 0; Cnt < 100; Cnt++)
            {
                Ret = TUSBSLC.Tusbs01lc_Single_Sample(devId, out tmpData);//データの取得
                if (Ret != 0)
                {
                    MessageBox.Show(TUSBSLC.GetErrMessage(Ret));
                    MeasStop();
                    return;
                }
                Data += tmpData;
            }
            Data /= 100.0;

            DataDisp.Text = Data.ToString("000000");

            Timer1.Enabled = true;//タイマー再開
        }
    }
}
