﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace S01LCTimer
{
    public partial class Form1 : Form
    {
        byte TotalCnt; //取込ボタン押下後からの現在の総取込数
        const short devID = 0;//装置のID
        
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short Ret;
            try
            {
                Ret = TUSBSLC.Tusbs01lc_Device_Open(devID);
                if (Ret != 0)
                {
                    MessageBox.Show(TUSBSLC.GetErrMessage(Ret));
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return;
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (StartBtn.Text == "中止")
                MeasAbort();
            TUSBSLC.Tusbs01lc_Device_Close(devID);
        }

        private void MeasStart()
        {
            short Ret;

            ResultView.Text = "";
            TotalCnt = 0;
            Ret = TUSBSLC.Tusbs01lc_Start_Sample(devID, 1);//取込開始
            Timer1.Enabled = true;
            StartBtn.Text = "中止";
        }

        private void MeasAbort()
        {
            Timer1.Enabled = false;
            StartBtn.Text = "取込";
        }

        private void StartBtn_Click(object sender, EventArgs e)
        {
            switch (StartBtn.Text)
            {
                case "取込":
                    MeasStart();
                    break;
                case "中止":
                    MeasAbort();
                    break;
            }
        }

        private void ZeroBtn_Click(object sender, EventArgs e)
        {
            short Ret;
            double tmpData;
            double Data;
            short Cnt;

            // 先ずゼロ調整をクリアする
            Ret = TUSBSLC.Tusbs01lc_Zero_Adj(devID, 0.0);
            if (Ret != 0)
            {
                MessageBox.Show(TUSBSLC.GetErrMessage(Ret));
                return;
            }

            // 調整が無い時の値を取得する(平均化)
            Data = 0.0;
            for (Cnt = 0; Cnt < 100; Cnt++)
            {
                Ret = TUSBSLC.Tusbs01lc_Single_Sample(devID, out tmpData);
                if (Ret != 0)
                {
                    MessageBox.Show(TUSBSLC.GetErrMessage(Ret));
                    return;
                }
                Data += tmpData;
            }
            Data /= 100.0;

            // 調整する
            Ret = TUSBSLC.Tusbs01lc_Zero_Adj(devID, Data);
            if (Ret != 0)
            {
                MessageBox.Show(TUSBSLC.GetErrMessage(Ret));
                return;
            }
        }

        private void Timer1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            short Ret;
            byte DataSize = 10;
            double[] Data = new double[DataSize];
            byte[] SerNum = new byte[DataSize];
            int Cnt;

            Timer1.Enabled = false;//一旦タイマー停止
            Ret = TUSBSLC.Tusbs01lc_Get_Datas(devID, Data, SerNum, ref DataSize);

            for (Cnt = 0; Cnt < DataSize; Cnt++)
            {
                ResultView.Text = ResultView.Text + Data[Cnt].ToString("00000 μひずみ") + "\r\n";
                TotalCnt += 1;
                if (TotalCnt > 9)
                {
                    MeasAbort();//終了
                    return;
                }
            }
            Timer1.Enabled = true;//タイマー再開
        }
    }
}
