﻿//------------------------------------------------------------
//            TUSB-S01LCドライバ操作用標準モジュール
//            2013/07/22
//            株式会社タートル工業
//-----------Copyright (C) 2013 Turtle Industry Co., Ltd.-----
//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;
using System.Runtime.InteropServices;

class TUSBSLC
{
    [DllImport("TUSBSLC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01lc_Device_Open(short Id);
    [DllImport("TUSBSLC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbs01lc_Device_Close(short Id);
    [DllImport("TUSBSLC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01lc_Single_Sample(short Id, out double Data);
    [DllImport("TUSBSLC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01lc_Start_Sample(short Id, short SampleRate);
    [DllImport("TUSBSLC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01lc_Get_Datas(short Id,[Out] double[] Data, [Out] byte[] SerNum,ref byte size);
    [DllImport("TUSBSLC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01lc_Zero_Adj(short Id,double Data);

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 7:
                return "オープンされていません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            default:
                return "不明なエラーです";
        }
    }
}

