﻿Public Class Form1
    Const devID As Short = 0 '装置のID

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim Ret As Short
        Ret = Tusbs01lc_Device_Open(devID)
        If (Ret <> 0) Then
            MsgBox(Tusbs01lc_GetErrMessage(Ret))
            Exit Sub
        End If
    End Sub

    Private Sub Form1_FormClosed(sender As System.Object, e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If StartStopBtn.Text = "停止" Then
            MeasStop()
        End If
        Tusbs01lc_Device_Close(devID)
    End Sub

    Private Sub MeasStart()
        Timer1.Enabled = True
        StartStopBtn.Text = "停止"
        ZeroBtn.Enabled = False
    End Sub

    Private Sub MeasStop()
        Timer1.Enabled = False
        StartStopBtn.Text = "開始"
        ZeroBtn.Enabled = True
    End Sub

    Private Sub StartStopBtn_Click(sender As System.Object, e As System.EventArgs) Handles StartStopBtn.Click
        Select Case StartStopBtn.Text
            Case "開始"
                MeasStart()
            Case "停止"
                MeasStop()
        End Select
    End Sub

    Private Sub ZeroBtn_Click(sender As System.Object, e As System.EventArgs) Handles ZeroBtn.Click
        Dim Ret As Short
        Dim tmpData As Double
        Dim Data As Double
        Dim Cnt As Short

        REM 先ずゼロ調整をクリアする
        Ret = Tusbs01lc_Zero_Adj(devID, 0.0)
        If (Ret <> 0) Then
            MsgBox(Tusbs01lc_GetErrMessage(Ret))
            Exit Sub
        End If

        REM 調整が無い時の値を取得する(平均化)
        Data = 0.0
        For Cnt = 0 To 99 Step 1
            Ret = Tusbs01lc_Single_Sample(devID, tmpData)
            If (Ret <> 0) Then
                MsgBox(Tusbs01lc_GetErrMessage(Ret))
                Exit Sub
            End If
            Data += tmpData
        Next Cnt
        Data = Data / 100.0

        REM 調整する
        Ret = Tusbs01lc_Zero_Adj(devID, Data)
        If (Ret <> 0) Then
            MsgBox(Tusbs01lc_GetErrMessage(Ret))
            Exit Sub
        End If
    End Sub

    Private Sub Timer1_Elapsed(sender As System.Object, e As System.Timers.ElapsedEventArgs) Handles Timer1.Elapsed
        Dim Ret As Short
        Dim Cnt As Integer
        Dim tmpData As Double
        Dim Data As Double

        Timer1.Enabled = False 'タイマーは一旦停止
        Data = 0.0
        For Cnt = 0 To 99
            Ret = Tusbs01lc_Single_Sample(devID, tmpData) 'データの取得
            If Ret <> 0 Then
                Tusbs01lc_GetErrMessage(Ret)
                MeasStop()
                Exit Sub
            End If
            Data += tmpData
        Next

        Data /= 100.0

        DataDisp.Text = Data.ToString("000000")

        Timer1.Enabled = True 'タイマー再開
    End Sub
End Class
