﻿Public Class Form1
    Dim TotalCnt As Byte '取込ボタン押下後からの現在の総取込数
    Const devID As Short = 0 '装置のID

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim Ret As Short
        Ret = Tusbs01lc_Device_Open(devID)
        If (Ret <> 0) Then
            MsgBox(Tusbs01lc_GetErrMessage(Ret))
            MsgBox("ID番号を確認してください")
            Exit Sub
        End If
    End Sub

    Private Sub Form1_FormClosed(sender As System.Object, e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If StartBtn.Text = "中止" Then
            MeasAbort()
        End If
        Tusbs01lc_Device_Close(devID)
    End Sub

    Private Sub MeasStart()
        Dim Ret As Short

        ResultView.Text = ""
        TotalCnt = 0
        Ret = Tusbs01lc_Start_Sample(devID, 1) '取込開始
        Timer1.Enabled = True
        StartBtn.Text = "中止"
    End Sub

    Private Sub MeasAbort()
        Timer1.Enabled = False
        StartBtn.Text = "取込"
    End Sub

    Private Sub StartBtn_Click(sender As System.Object, e As System.EventArgs) Handles StartBtn.Click
        Select Case StartBtn.Text
            Case "取込"
                MeasStart()
            Case "中止"
                MeasAbort()
        End Select
    End Sub

    Private Sub ZeroBtn_Click(sender As System.Object, e As System.EventArgs) Handles ZeroBtn.Click
        Dim Ret As Short
        Dim tmpData As Double
        Dim Data As Double
        Dim Cnt As Short

        REM 先ずゼロ調整をクリアする
        Ret = Tusbs01lc_Zero_Adj(devID, 0.0)
        If (Ret <> 0) Then
            MsgBox(Tusbs01lc_GetErrMessage(Ret))
            Exit Sub
        End If

        REM 調整が無い時の値を取得する(平均化)
        Data = 0.0
        For Cnt = 0 To 99 Step 1
            Ret = Tusbs01lc_Single_Sample(devID, tmpData)
            If (Ret <> 0) Then
                MsgBox(Tusbs01lc_GetErrMessage(Ret))
                Exit Sub
            End If
            Data += tmpData
        Next Cnt
        Data = Data / 100.0

        REM 調整する
        Ret = Tusbs01lc_Zero_Adj(devID, Data)
        If (Ret <> 0) Then
            MsgBox(Tusbs01lc_GetErrMessage(Ret))
            Exit Sub
        End If
    End Sub

    Private Sub Timer1_Elapsed(sender As System.Object, e As System.Timers.ElapsedEventArgs) Handles Timer1.Elapsed
        Dim Ret As Short
        Dim DataSize As Byte = 10
        Dim tData(DataSize - 1) As Double
        Dim SerNum(DataSize - 1) As Byte
        Dim Cnt As Integer

        Timer1.Enabled = False '一旦タイマー停止
        Ret = Tusbs01lc_Get_Datas(devID, tData, SerNum, DataSize)

        For Cnt = 0 To DataSize - 1
            ResultView.Text = ResultView.Text & tData(Cnt).ToString("00000 μひずみ") & vbCrLf
            TotalCnt += 1
            If TotalCnt > 9 Then
                MeasAbort() '終了
                Exit Sub
            End If
        Next
        Timer1.Enabled = True 'タイマー再開
    End Sub
End Class
